%global modname jnius
%global srcname py%{modname}
%global sum     Dynamic access to Java classes from Python

%if 0%{?fedora}
%bcond_without python3
%else
%bcond_with python3
%endif

Name:           python-%{modname}
Version:        1.1.1
Release:        6%{?dist}
Summary:        %{sum}

License:        MIT
URL:            https://github.com/kivy/%{srcname}
Source0:        %{url}/archive/%{version}.tar.gz#/%{srcname}-%{version}.tar.gz
# fix unicode issues, patch extracted from 61592eedb0e5efd9713d66fcbbc2026daa7851de
Patch0:         %{srcname}-unicode.patch

BuildRequires:  gcc
BuildRequires:  python2-devel
BuildRequires:  python2-Cython
BuildRequires:  python2-nose
BuildRequires:  python2-six
%if %{with python3}
BuildRequires:  python3-devel
BuildRequires:  python3-Cython
BuildRequires:  python3-nose
BuildRequires:  python3-six
%endif # with python3
BuildRequires:  ant
BuildRequires:  java-devel
BuildRequires:  %{_bindir}/sphinx-build

# FIXME odd bug with wrong default architecture (i386)
# https://github.com/kivy/pyjnius/issues/307
# https://github.com/kivy/pyjnius/issues/306
ExcludeArch:    i686 ppc64 ppc64le s390x armv7hl aarch64

%description
%{summary}.

%package     -n python2-%{srcname}
Summary:        %{sum}
Requires:       java-headless
Requires:       python2-six
%{?python_provide:%python_provide python2-%{srcname}}
Provides:       python2-%{modname}

%description -n python2-%{srcname}
%{summary}.

%if %{with python3}
%package     -n python3-%{srcname}
Summary:        %{sum}
Requires:       java-headless
Requires:       python3-six
%{?python_provide:%python_provide python3-%{srcname}}
Provides:       python3-%{modname}


%description -n python3-%{srcname}
%{summary}.
%endif # with python3

%package        doc
Summary:        Documentation files for %{srcname}
BuildArch:      noarch

%description    doc
%{summary}.


%prep
%autosetup -p1 -n %{srcname}-%{version}

%build
%py2_build

%if %{with python3}
# force regenerate (cythonize) as there are python version dependent parts
rm %{modname}/*.c
%py3_build
%endif

make -C docs html

# build java classes for tests
# there is also Makefile, but it calls python setup.py build_ext --inplace
# together with ant, so we don't use it not to build python bits twice
ant all


%install
%py2_install
%{?with_python3:%py3_install}

%check
pushd tests
export CLASSPATH=../build/test-classes:../build/classes
export JAVA_HOME=%{_prefix}/lib/jvm/java
PYTHONPATH=%{buildroot}%{python2_sitearch} %{__python2} -m nose -v
%{?with_python3:PYTHONPATH=%{buildroot}%{python3_sitearch} %{__python3} -m nose -v}
popd


%files -n python2-%{srcname}
%license LICENSE
%doc *.md
%{python2_sitearch}/%{modname}/
%{python2_sitearch}/%{modname}_config.py*
%{python2_sitearch}/%{srcname}-%{version}-py*.egg-info/

%if %{with python3}
%files -n python3-%{srcname}
%license LICENSE
%doc *.md
%{python3_sitearch}/%{modname}/
%{python3_sitearch}/%{modname}_config.py*
%{python3_sitearch}/%{srcname}-%{version}-py*.egg-info/
%{python3_sitearch}/__pycache__/%{modname}_config.cpython-*.pyc
%exclude %{python3_sitearch}/__pycache__
%endif # with python3

%files doc
%license LICENSE
%doc docs/build/html/


%changelog
* Wed Jul 18 2018 Raphael Groner <projects.rg@smart.ms> - 1.1.1-6
- several fixes for Python

* Sat Jul 14 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.1-5
-- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Tue Jun 19 2018 Miro Hrončok <mhroncok@redhat.com> - 1.1.1-4
- Rebuilt for Python 3.7

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Tue Oct 24 2017 Raphael Groner <projects.rg@smart.ms> - 1.1.1-2
- be more precisely about owned files

* Sun Oct 22 2017 Raphael Groner <projects.rg@smart.ms> - 1.1.1-1
- initial
